/**********************************************************
*       Company:    Pixel Semiconductor, Inc.      
*       Project:    2070/2080 Diagnostics
*       File Name:  EvalDiag.h
*
*       Module Abstract:
*
***********************************************************
*       Author: Kyle Pratt
*       Date:   8/27/92
*
*       Revision History:
*       WHO             WHEN            WHAT/WHY/HOW
*
*
*********************************************************/

/* typedef's --------------------------------------------*/
typedef enum tagRegAccess {READ,WRITE,READLOOP,WRITELOOP,WRITEPOL} RegAccess;
typedef enum tagFlag  {CLEAR,SET} Flag;
typedef enum tagProcType {PX2070,PX2080,PX2085,VidMod,Unknown} ProcType;

// define level of nesting allowed with monitor macros
#define MACRO_LEVELS    8

// Some values for testing the 2070

#define MAXSHORTPATS    37



// Some values for testing the 484 module
#define MAXPATTERNS     20
#define BT281ADDRLMASK  0xff
#define BT281ADDRHMASK  0x03
#define BT281CR0MASK    0xfc
#define BT281CR1MASK    0xff
#define CR0_ADDRL_281   0x12
#define CR0_ADDRH_281   0x03
#define DA_RAML_281     0x00
#define DA_RAMH_281     0x00
#define MAX281RAM       0x300
#define MATRIX_LOW_281  0x00
#define MATRIX_HI_281   0x03
#define MAX281MATRIX    9
#define BT281MTRXMASK   0x7
#define BT484CR0MASK    0x7f
#define BT484CR1MASK    0x7f
#define BT484CR2MASK    0xff
#define BT484CRSRMASK   0x0f
#define BT484CURSORRAM  256
#define BT484CRSRPALET  4
#define BT484PALETTE    256
#define DEFAULT484CR0   2
#define DEFAULT484CR2   3

// define some values for the diagnostic test flag array

#define MAXFLAGS        ((MAX2070FLAGS * MAX2070COUNT) + \
			 (MAX2080FLAGS * MAX2080COUNT) + \
			 (MAXVIDMODFLAGS + MAXVIDMODCOUNT))
#define MAX2080FLAGS    5
#define MAX2085FLAGS    5
#define MAX2070FLAGS    15
#define MAX484FLAGS     9
#define MAXVIDMODFLAGS  2
#define FLAGBASE2070    0
#define FLAGBASE2080    (MAX2070FLAGS * MAX2070COUNT)
#define FLAGBASE2085    (FLAGBASE2080 + (MAX2080FLAGS * MAX2080COUNT))
#define FLAGBASEVIDMOD  (FLAGBASE2085 + (MAX2085FLAGS * MAX2085COUNT))

#define VGA_GRAPHICS 0
#define PX1085_GRAPHICS 1
#define AUDIO_MUTE 0
#define AUDIO_ON 1
#define EXT_AUDIO 0
#define INT_AUDIO 1

/* MACRO's ---------------------------------------------*/

#define FINDSETUP        if (iMenuCount < iSwitchValue)  \
			   {                             \
			   E_GoodCmd=CLEAR;                \
			   break;                        \
			   }                             \
			 if (iIndexArray[iIndex]<MAX2070COUNT) \
			   { \
			   Setup2070(E_FlagArray,iIndexArray[iIndex]); \
			   break;\
			   } \
			 if ((iIndexArray[iIndex]>=PX2080BASE) && (iIndexArray[iIndex]<(PX2080BASE+MAX2080COUNT))) \
			   { \
			   Setup2080(E_FlagArray,(iIndexArray[iIndex]-MAX2070COUNT)); \
			   break; \
			   }


#define GETNUMBER        rewind(stdin);                \
			 if(scanf("%d",&iInCmd) !=1)    \
			   {                           \
			   continue;                   \
			   }                           \
			 rewind(stdin);

#define GETHEXNUMBER     if(sscanf(cInCmd,"%x") !=1)    \
			   {                           \
			   printf("Bad Value Try Again\n"); \
			   continue;                   \
			   }                           \
			 E_GoodVal = SET;



#define STRINGTONUMBER  if ((cInCmd[2] == '\n') || (cInCmd[2] == ' ') || (cInCmd[2] == '\0'))                                            \
			  *pdwCommand = ((long)cInCmd[0] << 8) + (long)cInCmd[1];            \
			else if ((cInCmd[3] =='\n') || (cInCmd[3] == ' ') || (cInCmd[3] == '\0'))                                        \
			  *pdwCommand = (((long)cInCmd[0] <<16) + ((long)cInCmd[1] << 8) +   \
				       ((long)cInCmd[2]));                                 \
			else                                                               \
			  *pdwCommand = (((long)cInCmd[0] << 24) + ((long)cInCmd[1] << 16) + \
				       ((long)cInCmd[2] << 8)  + ((long)cInCmd[3]));
