/**********************************************************
*
*       Copyright (c) 1994 Pixel Semiconductor, Inc.  All rights reserved.
*
*       File Name: I2CAPI.H
*
*       Module Abstract:
*       ----------------
*       Header file for I2CAPI.H
*
***********************************************************
*
*       Author: Dan Davis
*       Date:   6/1/94
*
*       Revision History:
*       -----------------
*       WHO             WHEN            WHAT/WHY/HOW
*       ---             ----            ------------
*       Frank Xu      9-9-94        Changed the structure definition
*
**********************************************************/

#ifndef I2CAPI
#define I2CAPI

#ifndef BYTE
#define BYTE unsigned char
#endif

#ifndef LPBYTE
#define LPBYTE unsigned char *
#endif

#ifndef LPVOID
#define LPVOID void *
#endif

#ifndef WORD
#define WORD unsigned short
#endif

#ifndef UINT
#define UINT unsigned int
#endif

/*
 *    Defines
 */

// Address usage definition

#define NOTUSED                  0
#define ADDRESSUSED              1
#define SUBADDRESSUSED           2
#define SUB_SUBADDRESSUSED       3

// Register size definition

#define REGSIZE8BITS             8
#define REGSIZE12BITS            12
#define REGSIZE16BITS            16

#define I2C_ERROR                1
#define I2C_SUCCESS              0

//    I2C Address Data Structure.

typedef struct tagI2CINFO
{
  BYTE PortNumber;
  BYTE address;
  BYTE subaddress;
  BYTE subsubaddress;
  BYTE address_option;
  BYTE regsize;
} I2CINFO;

typedef I2CINFO *LPI2CINFO;

/*
*   Exported Function Prototypes.
*/

#ifdef cplusplus
extern "C" {
#endif

BYTE DDC2BInit () ;
BYTE I2cCheck (LPI2CINFO);
BYTE I2CGetWriteMask ( LPBYTE lpbyWriteOnlyBits ) ;
BYTE I2CSetWriteMask ( BYTE byWriteOnly ) ;
BYTE i2c_read (LPVOID, UINT, LPI2CINFO);
BYTE i2c_write (LPVOID, UINT, LPI2CINFO);

#ifdef cplusplus
}
#endif

#endif
 
