/* $Id: initpx.c,v 1.2 1997/03/09 06:52:08 todd Exp $ */

/* #includes --------------------------------------------*/
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include "pxhil.h"
#include "iodvp.h"
#include "iomd.h"
#include "iovid.h"

/* Global Configuration Array */
void *G_pvConfigArray[MAXCONFIGARRAY];
PortType G_Px2070PortType=UNDEFINED;
SwMode G_SwMode = REAL_MODE;
unsigned long G_Px2070BaseAddress;
unsigned long G_Px2080BaseAddress;


/* Get enough memory for the mem mapped io case */
unsigned long G_dwDVPPortArray[(sizeof(PX2070Ports)*MAX2070COUNT/4)];
unsigned long G_wMD1PortArray[(sizeof(PX2080Ports)*MAX2080COUNT/4)];
unsigned short G_wVIDPortArray[(sizeof(VIDPorts)*MAXVIDMODCOUNT/2)];
unsigned short G_wGLUEPortArray[(sizeof(PX0001Ports)*MAX0001COUNT/2)];
char G_cKeyWord[64];
char G_cConfigString[MAXLINELENGTH];
char G_cInputBuffer[MAXLINELENGTH];
int iCount;

int BuildStructsPX()

{
  int iError=0;
  int  i,iProcCount;
  char *pcSysConfigFileName;
  FILE *pfSysConfigFile;
  PX2070Ports *pPX2070Ports;
  PX2080Ports *pPX2080Ports;
  PX0001Ports *pPX0001Ports;
  VIDPorts *pVIDPorts;
  static unsigned long dwBir,dwPort0,dwPort1,dwPort2,dwPort3,dwPort4,dwRamType,dwTemp;
  static unsigned long dwHcr,dwXOFF,dwYOFF,dwWinDelta;
  static unsigned short wPort0, wPort1;

  for (i=0;i<MAXCONFIGARRAY;i++)
    G_pvConfigArray[i]=NULL;

  G_Px2080PortType=UNDEFINED;
  G_Px2085PortType=UNDEFINED;


  /********************************************************************
  * Find the system configuration file pointed to by the SYS_CONF     *
  * environment variable. If none is found, get the default file      *
  * SYSCFG in this directory                                          *
  ********************************************************************/

  if ((pcSysConfigFileName = (char *) getenv("SYS_CONF")) == NULL)
  {
    printf("Unable to locate SYS_CONF environment variable.\n");
    printf("Using default file SYSCFG.\n");
    pcSysConfigFileName = "syscfg";
  }
  /********************************************************************
  * Attempt to open the system config file.                           *
  ********************************************************************/
  if ((pfSysConfigFile = fopen(pcSysConfigFileName,"r")) == NULL)
  {
    printf("Unable to open SysConfigFile\n");
    iError = -1;
    goto ERROREXIT;
  }


  /*************************************************************
  * Construct keyword for the 0001                             *
  *************************************************************/

  sprintf(G_cKeyWord, "%s%","PX0001");

  /*************************************************************
  * Look for this 0001's keyword in the system configuration   *
  * file. If not found, go to the next one.                    *
  *************************************************************/

  utlGetControlString(pfSysConfigFile, MAXLINELENGTH);


  /*******************************************************************
  * Parse the keyword string and test for correct format.            *
  *******************************************************************/

  if (sscanf(G_cConfigString, "%x %x",&wPort0,&wPort1)==2)
  {

    /*******************************************************************
    * configure memory for the data structure and update it             *
    *******************************************************************/

    pPX0001Ports =  (PX0001Ports *)G_wGLUEPortArray;
    G_pvConfigArray[PX0001BASE] = pPX0001Ports;
    pPX0001Ports->PX0001Port0 = wPort0;
    pPX0001Ports->PX0001Port1 = wPort1;
  }

  G_Px2070PortType = ISA_MAPPED;
  G_cConfigString[0]=0;
  if (G_Px2070PortType != UNDEFINED)
  {

    /*************************************************************
    * Construct keyword for the 2070                             *
    *************************************************************/

    sprintf(G_cKeyWord, "%s%","PX1070");

    /*************************************************************
    * Look for this 2070's keyword in the system configuration   *
    * file. If not found, go to the next one.                    *
    *************************************************************/

    utlGetControlString(pfSysConfigFile, MAXLINELENGTH);


    /*******************************************************************
    * Parse the keyword string and test for correct format.            *
    *******************************************************************/

    if (sscanf(G_cConfigString, "%lx %lx %lx %lx %lx %lx %lx %lx %lx %lx",
		&dwPort0,&dwPort1,&dwPort2,&dwPort3,&dwPort4,&dwRamType,
		&dwHcr,&dwWinDelta, &dwXOFF,&dwYOFF)==10)
    {

      /*******************************************************************
      * configure memory for the data structure and update it             *
      *******************************************************************/

      pPX2070Ports =  (PX2070Ports *)G_dwDVPPortArray;
      G_pvConfigArray[PX2070BASE] = pPX2070Ports;
      pPX2070Ports->PX2070Port0 = dwPort0;
      pPX2070Ports->PX2070Port1 = dwPort1;
      pPX2070Ports->PX2070Port2 = dwPort2;
      pPX2070Ports->PX2070Port3 = dwPort3;
      pPX2070Ports->PX2070Port4 = dwPort4;
      pPX2070Ports->PX2070RamType = dwRamType;
      pPX2070Ports->PX2070HCR = dwHcr;
      pPX2070Ports->PX2070WIN_DELTA = dwWinDelta;
      pPX2070Ports->PX2070X_OFFSET = dwXOFF;
      pPX2070Ports->PX2070Y_OFFSET = dwYOFF;

    } /* if */
  }
  /*  If there is a 2070 set the first one to be the current one */
  if (G_pvConfigArray[PX2070BASE] != NULL)
    ioSetCurrentDVP(0);

  /*  Do 2080 stuff */

  G_Px2080PortType = IO_MAPPED;
  G_cConfigString[0]=0;
  if (G_Px2080PortType != UNDEFINED)
  {

    /*************************************************************
    * Construct keyword for the 1085                             *
    *************************************************************/

    sprintf(G_cKeyWord, "%s%","PX1085");

    /*************************************************************
    * Look for this 1085's keyword in the system configuration   *
    * file. If not found, go to the next one.                    *
    *************************************************************/

    utlGetControlString(pfSysConfigFile, MAXLINELENGTH);


    /*******************************************************************
    * Parse the keyword string and test for correct format.            *
    *******************************************************************/
    iCount=0;
    iCount=sscanf(G_cConfigString, "%lx", &dwPort0);
    if(iCount==1)
    {
      /*******************************************************************
      * Allocate memory for the data structure and update it             *
      *******************************************************************/
      pPX2080Ports = (PX2080Ports *) G_wMD1PortArray;
      G_pvConfigArray[PX2080BASE] = pPX2080Ports;
      pPX2080Ports->PX2080Bir   = 1;
      pPX2080Ports->PX2080Port0 = dwPort0;
      pPX2080Ports->PX2080Port1 = dwPort0+1;
      pPX2080Ports->PX2080Port2 = dwPort0+2;
      pPX2080Ports->PX2080Port3 = dwPort0+3;
      pPX2080Ports->PX2080Port4 = dwPort0+4;
      pPX2080Ports->PX2080Port5 = dwPort0+5;
      pPX2080Ports->PX2080Port6 = dwPort0+6;
      pPX2080Ports->PX2080Port7 = dwPort0+7;
      pPX2080Ports->PX2080Port8 = dwPort0+8;
      pPX2080Ports->PX2080Port9 = dwPort0+9;
      pPX2080Ports->PX2080Port10 = dwPort0+10;
      pPX2080Ports->PX2080Port11 = dwPort0+11;
      pPX2080Ports->PX2080Port12 = dwPort0+12;
      pPX2080Ports->PX2080Port13 = dwPort0+13;
      pPX2080Ports->PX2080Port14 = dwPort0+14;
      pPX2080Ports->PX2080Port15 = dwPort0+15;
      pPX2080Ports->PX2080Port16 = dwPort0+16;
      pPX2080Ports->PX2080Port17 = dwPort0+17;
      pPX2080Ports->PX2080Port18 = dwPort0+18;
      pPX2080Ports->PX2080Port19 = dwPort0+19;
      pPX2080Ports->PX2080Port20 = dwPort0+20;
      pPX2080Ports->PX2080Port21 = dwPort0+21;
      pPX2080Ports->PX2080Port22 = dwPort0+22;
      pPX2080Ports->PX2080Port23 = dwPort0+23;
      pPX2080Ports->PX2080Port24 = dwPort0+24;
      pPX2080Ports->PX2080Port25 = dwPort0+25;
      pPX2080Ports->PX2080Port26 = dwPort0+26;
      pPX2080Ports->PX2080Port27 = dwPort0+27;
      pPX2080Ports->PX2080Port28 = dwPort0+28;
      pPX2080Ports->PX2080Port29 = dwPort0+29;
      pPX2080Ports->PX2080Port30 = dwPort0+30;
      pPX2080Ports->PX2080Port31 = dwPort0+31;
    }
  } /*  if */

  /*  If there is a 2080 set the first one to be the current one */
  if (G_pvConfigArray[PX2080BASE] != NULL)
  {
    G_eWhichDac = Px2080;
    ioSetCurrentMD(0);
  }

  G_cConfigString[0]=0;
  /*************************************************************
  * Construct keyword for the VID module                       *
  *************************************************************/

  sprintf(G_cKeyWord, "%s%","PXVIDMOD");

  /*************************************************************
  * Look for this VID mod's keyword in the system configuration    *
  * file. If not found, go to the next one.                    *
  *************************************************************/

  utlGetControlString(pfSysConfigFile, MAXLINELENGTH);

  /*******************************************************************
  * Parse the keyword string and test for correct format.            *
  *******************************************************************/
  if (sscanf(G_cConfigString, "%x", &wPort0) ==1)
  {

    /*******************************************************************
    * Allocate memory for the data structure and update it             *
    *******************************************************************/
    pVIDPorts = (VIDPorts *) G_wVIDPortArray;
    G_pvConfigArray[3] = pVIDPorts;
    pVIDPorts->VIDPort0 = wPort0;
  }



fclose(pfSysConfigFile);

ERROREXIT:
return(iError);
} /*  End BuildStructsPX */

/**********************************************************
*
*       File Name:  InitHil.c
*
*       Module Abstract:  This routine gets hardware configuration
*               information from a file and constructs the data
*               structures describing the hardware I/O ports.
*
*       Calling Sequence:
*       iError = PxHilOpen();
*
*       Input Parameters:
*       none
*
*       Output Parameters:
*       int iError      return status 0 = success -1 = fail
*
*       Global Variables:
*       G_pvConfigArray[]
***********************************************************
*       Author: Kyle Pratt
*       Date:   10/6/92
*
*       Revision History:
*       WHO             WHEN            WHAT/WHY/HOW
*
*
*********************************************************/
int OpenPX()
{
int i,iError;

/*  Initialize the array */
for (i =0; i < MAXCONFIGARRAY; i++)
  G_pvConfigArray[i] = NULL;

/*  Build the data structures */
if ((iError = BuildStructsPX()) !=0)
  return(iError);
else
  {
  /*  do some init things here eventually */
  return(iError);
  }
} /*  End OpenPX() */

/***********************************************************************
*
*       File Name:  initpx.c
*
*       Module Abstract:
*
*       Calling Sequence:
*       iError = utlGetControlString(pfFile, iLength);
*
*       Input Parameters:
*       *FILE   pfFile           pointer to control file
*       int     iLength          Buffer length
*
*       Output Parameters:
*       *char   pControlString  pointer to string with pKeyWord
*       int    iError           Error return code:
*                                0 - Keyword found
*                               -1 - Keyword not found
*                               -2 - Keyword found but line too long
*
*       Global Variables:
*       none
************************************************************************
*       Author: Kyle Pratt
*       Date:   9/15/92
*
*       Revision History:
*       WHO             WHEN            WHAT/WHY/HOW
*
*
***********************************************************************/

int utlGetControlString(pfFile,iLength)
FILE  *pfFile;
int      iLength;
{
char   *pcTempString;
char  *cInputBuffer[MAXLINELENGTH];

/*************************************************************
* Rewind input file.                                         *
*************************************************************/

rewind(pfFile);

/*************************************************************
* Search the file for the keyword.                           *
*************************************************************/

for (;;)
  {
  /*************************************************************
  * Find the next line that is not a comment.                  *
  *************************************************************/

  for (;;)
    {
    /*************************************************************
    * If we have reached EOF & keyword not found, return(-1).    *
    *************************************************************/

    if (fgets(G_cInputBuffer, MAXLINELENGTH,pfFile) == NULL)
      {
      return(-1);
      }

    if ((G_cInputBuffer[0] !='#') &&
	(G_cInputBuffer[0] !='*') &&
	(G_cInputBuffer[0] !='\n') &&
	(G_cInputBuffer[0] !='\t') &&
	(G_cInputBuffer[0] !=' '))
	{
	break;
	}
    } /* for */

  /*************************************************************
  * We have found a non-comment line. Find the first whitespace*
  * or newline character in the input buffer in order to
  * isolate the keyword.
  *************************************************************/

  for (pcTempString = G_cInputBuffer; (*pcTempString !=' ') &&
				(*pcTempString !='\t') &&
				(*pcTempString !='\n'); pcTempString++)
    {
    /* nothing */
    }

  /*************************************************************
  * Does the input keyword match the input buffer keyword ?    *
  *************************************************************/

  if (!strncmp(G_cInputBuffer,G_cKeyWord, pcTempString - G_cInputBuffer))
    {

    /*************************************************************
    * Find the next non-whitespace character in the input buffer.*
    *************************************************************/

    for (;(*pcTempString == ' ') || (*pcTempString == '\t'); pcTempString++)
      {
      /* nothing */
      }

    /*************************************************************
    * Check the length of the string                             *
    *************************************************************/

    if ((strlen(pcTempString) -1) > iLength)
      {
      /*************************************************************
      * If the control string that we found is too long,           *
      * return a value indicating such.                            *
      *************************************************************/

      return(-2);
      }
    else
      {
      /*************************************************************
      * The control string is OK. Remove the newline               *
      * character from the control string and return with success. *
      *************************************************************/

      pcTempString[strlen(pcTempString) -1] = '\0';
      strcpy(G_cConfigString, pcTempString);
      return(0);
      }
    } /* for ; */
  }   /* if (!strncmp) */
}  /*  End utlGetControlString */



int GetLoopCount()

{
  int  i;
  char *pcSysConfigFileName;
  FILE *pfSysConfigFile;
  int iCount0;

  /********************************************************************
  * Find the system configuration file pointed to by the SYS_CONF     *
  * environment variable. If none is found, get the default file      *
  * SYSCFG in this directory                                          *
  ********************************************************************/

  if ((pcSysConfigFileName = (char *) getenv("SYS_CONF")) == NULL)
  {
    /* printf("Unable to locate SYS_CONF environment variable.\n"); */
    /* printf("Using default file SYSCFG.\n"); */
    pcSysConfigFileName = "syscfg";
  }
  /********************************************************************
  * Attempt to open the system config file.                           *
  ********************************************************************/
  if ((pfSysConfigFile = fopen(pcSysConfigFileName,"r")) == NULL)
  {
    printf("Unable to open SysConfigFile\n");

    goto ERROREXIT;
  }
  /*************************************************************
  * Construct keyword for the 0001                             *
  *************************************************************/

  sprintf(G_cKeyWord, "%s%","LoopCount");

  /*************************************************************
  * Look for this 0001's keyword in the system configuration   *
  * file. If not found, go to the next one.                    *
  *************************************************************/

  utlGetControlString(pfSysConfigFile, MAXLINELENGTH);

  /*******************************************************************
  * Parse the keyword string and test for correct format.            *
  *******************************************************************/

  if (sscanf(G_cConfigString, "%d",&iCount0)!=1)
  {
    printf("Invalid config string in system config file\n");
    goto ERROREXIT;
  }

  fclose(pfSysConfigFile);

  ERROREXIT:
  return(iCount0);
} /*  End GetLoopCount */

int GetErrorCount()

{
  int  i;
  char *pcSysConfigFileName;
  FILE *pfSysConfigFile;
  int iCount0;

  /********************************************************************
  * Find the system configuration file pointed to by the SYS_CONF     *
  * environment variable. If none is found, get the default file      *
  * SYSCFG in this directory                                          *
  ********************************************************************/

  if ((pcSysConfigFileName = (char *) getenv("SYS_CONF")) == NULL)
  {
    /* printf("Unable to locate SYS_CONF environment variable.\n"); */
    /* printf("Using default file SYSCFG.\n"); */
    pcSysConfigFileName = "syscfg";
  }
  /********************************************************************
  * Attempt to open the system config file.                           *
  ********************************************************************/
  if ((pfSysConfigFile = fopen(pcSysConfigFileName,"r")) == NULL)
  {
    printf("Unable to open SysConfigFile\n");

    goto ERROREXIT;
  }
  /*************************************************************
  * Construct keyword for the 0001                             *
  *************************************************************/

  sprintf(G_cKeyWord, "%s%","ErrorCount");

  /*************************************************************
  * Look for this 0001's keyword in the system configuration   *
  * file. If not found, go to the next one.                    *
  *************************************************************/

  utlGetControlString(pfSysConfigFile, MAXLINELENGTH);

  /*******************************************************************
  * Parse the keyword string and test for correct format.            *
  *******************************************************************/

  if (sscanf(G_cConfigString, "%d",&iCount0)!=1)
  {
    printf("Invalid config string in system config file\n");
    goto ERROREXIT;
  }

  fclose(pfSysConfigFile);

  ERROREXIT:
  return(iCount0);
} /*  End GetErrorCount */
