/* $Id: iodvp.c,v 1.3 1997/03/09 06:52:09 todd Exp $ */

#include <asm/io.h>
#include <string.h>

#include "poke.h"
#include "iodvp.h"

extern SwMode G_SwMode;
extern unsigned long G_Px2070BaseAddress;
extern PortType G_Px2070PortType;
extern void *G_pvConfigArray[MAXCONFIGARRAY];
static int S_iCurrentDVP;
static PX2070Ports *S_pCurrentDVPPorts;
static unsigned short S_wDebugRegister;

unsigned short loc_DVP(char r)
{
	switch(r)
	{
	case 0: return S_pCurrentDVPPorts->PX2070Port0;
	case 1: return S_pCurrentDVPPorts->PX2070Port1;
	case 2: return S_pCurrentDVPPorts->PX2070Port2;
	case 3: return S_pCurrentDVPPorts->PX2070Port3;
	case 4: return S_pCurrentDVPPorts->PX2070Port4;
	default: exit(3);
	}
}

void ioRDTWriteDVP(unsigned short wIndex, unsigned short wData)
{
	outw(wIndex,S_pCurrentDVPPorts->PX2070Port2);
	outw(wData,S_pCurrentDVPPorts->PX2070Port3);
	return;
}
unsigned short ioRDTReadDVP(unsigned short wIndex)
{
	outw(wIndex,S_pCurrentDVPPorts->PX2070Port2);
	return inw(S_pCurrentDVPPorts->PX2070Port3);
}

void ioOCSWriteDVP(unsigned short wData)
{
	outw(wData,S_pCurrentDVPPorts->PX2070Port1);
	return;
}
unsigned short ioOCSReadDVP(void)
{
	return inw(S_pCurrentDVPPorts->PX2070Port1);
}

unsigned short ioCSUReadDVP(void)
{
	return inw(S_pCurrentDVPPorts->PX2070Port0);
}

void ioRINWriteDVP(unsigned short wData)
{
	outw(wData,S_pCurrentDVPPorts->PX2070Port2);
	return;
}
unsigned short ioRINReadDVP()
{
	return inw(S_pCurrentDVPPorts->PX2070Port2);
}

int ioLutWriteDVP(wIndex, pbList, iCount)
unsigned short wIndex;
unsigned char *pbList;
int            iCount;
{
	unsigned short wWriteVal;

	if(((wIndex * 3 + iCount) <= MAX_IPU1_LUT))
	{
		ioRDTWriteDVP(IPU1_LRB,wIndex);
		while(iCount>0)
		{
			wWriteVal = (unsigned short) *pbList;
			ioRDTWriteDVP(IPU1_LRD,wWriteVal);
			pbList++;
			iCount--;
		}
	}
	else
		return -1;
	return 0;
}
int ioLutReadDVP(wIndex, pbList, iCount)
unsigned short wIndex;
unsigned char *pbList;
int iCount;
{
	unsigned short wReadVal;

	if(((wIndex * 3 + iCount) > MAX_IPU1_LUT))
		return -1;

	ioRDTWriteDVP(IPU1_LRB,wIndex);

	while(iCount>0)
	{
		wReadVal = ioRDTReadDVP(IPU1_LRD);
		*pbList = (unsigned char) (wReadVal & IPU1_LRD_MASK);
		pbList++;
		iCount--;
	}

	return 0;
}

long ioSetCurrentDVP(int iProc)
{
	if((iProc >= MAX2070COUNT) || (!G_pvConfigArray[PX2070BASE]))
		return -1;

	S_iCurrentDVP = iProc;
	S_pCurrentDVPPorts = (PX2070Ports *) G_pvConfigArray[PX2070BASE];
	return 0;
}

int ioGetCurrentDVP()
{
	int iProc;
	if (S_pCurrentDVPPorts == NULL)
		iProc = -1;
	else
		iProc = S_iCurrentDVP;
	return iProc;
}

void (*lpOutWordFuncs[PX_PORT_TYPES])(unsigned long, unsigned short) =
{ MemOutWordFunc,
  IoOutWordFunc };
unsigned short (*lpInWordFuncs[PX_PORT_TYPES])(unsigned long) =
{ MemInWordFunc,
  IoInWordFunc
  };

void MemOutWordFunc(dwPortAddress,wData)
unsigned long dwPortAddress;
unsigned short wData;
{
	printf("MemOutWordFunc: Not implemented\n");
	/*outw(wData,duPortAddress); */
	return;
}
unsigned short MemInWordFunc(dwPortAddress)
unsigned long dwPortAddress;
{
	printf("MemInWordFunc: Not implemented\n");
	/*return inw(duPortAddress); */
	return 0;
}

void IoOutWordFunc(dwPortAddress,wData)
unsigned long dwPortAddress;
unsigned short wData;
{
  outw_p(wData,(unsigned)(dwPortAddress & 0xffff));
} /* End IoOutWordFunc */
unsigned short IoInWordFunc(dwPortAddress)
unsigned long dwPortAddress;
{ return inw_p((unsigned)(dwPortAddress & 0xffff));
} /* End IoInWordFunc */

void ioMDTWriteDVP(unsigned long lData)
{
	unsigned short wWriteValL,wWriteValH;
	wWriteValL = (unsigned short) (lData & 0xffff);
	wWriteValH = (unsigned short) (lData >> 16);
	lpOutWordFuncs[G_Px2070PortType](S_pCurrentDVPPorts->PX2070Port4,wWriteValL);
	lpOutWordFuncs[G_Px2070PortType](S_pCurrentDVPPorts->PX2070Port4,wWriteValH);
}
unsigned long ioMDTReadDVP(void)
{
	return ((inw(S_pCurrentDVPPorts->PX2070Port4)&0xffff) | (inw(S_pCurrentDVPPorts->PX2070Port4)<<16));
}
	

void ioMDTShortWriteDVP(unsigned short wData)
{
	outw(wData,S_pCurrentDVPPorts->PX2070Port4);
	return;
}

int ioMDTBlastReadDVP(unsigned short *pwList, unsigned long dwCount)
{
	unsigned long i;

	for ( i = 0; i < dwCount; i++ )
		pwList[ i ] = inw(S_pCurrentDVPPorts->PX2070Port4);

	return( 1 );
}

unsigned short ioMDTShortReadDVP()
{
	return inw(S_pCurrentDVPPorts->PX2070Port4);
}
