#ifndef __MD_KEYWORD__
#define __MD_KEYWORD__

typedef enum tagMEDIADAC{Px2080,Px2085}MEDIADAC;

// Global variables
#ifdef IOMD
MEDIADAC G_eWhichDac;
PortType G_Px2085PortType;
PortType G_Px2080PortType;
#endif
#ifndef IOMD
extern MEDIADAC G_eWhichDac;
extern PortType G_Px2085PortType;
extern PortType G_Px2080PortType;
#endif

// defines --------------------------------------
#define CAW_PORT        0
#define CCD_PORT        1
#define ASC_PORT        2
#define CAR_PORT        3
#define GFC_PORT        0
#define CSC_PORT        1
#define GSR_PORT        2
#define CPR_PORT        3
#define CXL_PORT        0
#define CXH_PORT        1
#define CYL_PORT        2
#define CYH_PORT        3
#define VFC_PORT        0
#define GOC_PORT        1
#define SAR_PORT        2
#define VGW_PORT        0
#define VGD_PORT        1
#define VGR_PORT        3
#define GCKR_PORT       0
#define GCKG_PORT       1
#define GCKB_PORT       2
#define GKMR_PORT       0
#define GKMG_PORT       1
#define GKMB_PORT       2



#define MD_BLOCK_0      0x80
#define MD_BLOCK_1      0x1
#define MD_BLOCK_2      0x2
#define MD_BLOCK_3      0x3
#define MD_BLOCK_4      0x4
#define MD_BLOCK_5      0x5
#define MD_BLOCK_6      0x6
#define MD_BLOCK_7      0x7
#define MD_BLOCK_8      0x8
#define MD_BLOCK_9      0x9
#define MD_BLOCK_A      0xa
#define MD_BLOCK_B      0xb
#define MD_PORT_0       0x0
#define MD_PORT_1       0x1
#define MD_PORT_2       0x2
#define MD_PORT_3       0x3
#define MD_PRIM_OFFSET  0x0
#define MD_SEC_OFFSET   0x20


#define PX2080_LAW    0x00
#define PX2080_LCD    0x01
#define PX2080_LPM    0x02
#define PX2080_LAR    0x03
#define PX2080_CAW    0x04
#define PX2080_CCD    0x05
#define PX2080_ASC    0x06
#define PX2080_CAR    0x07
#define PX2080_GFC    0x08
#define PX2080_CSC    0x09
#define PX2080_GSR    0x0a
#define PX2080_CR3    0x0a
#define PX2080_CPR    0x0b
#define PX2080_CXL    0x0c
#define PX2080_CXH    0x0d
#define PX2080_CYL    0x0e
#define PX2080_CYH    0x0f
#define PX2080_VFC    0x10
#define PX2080_GOC    0x11
#define PX2080_SAR    0x12
#define PX2080_RSV1   0x13
#define PX2080_VGW    0x14
#define PX2080_VGD    0x15
#define PX2080_RSV2   0x16
#define PX2080_VGR    0x17
#define PX2080_CKR    0x18
#define PX2080_CKG    0x19
#define PX2080_CKB    0x1a
#define PX2080_RSV3   0x1b
#define PX2080_KMR    0x1c
#define PX2080_KMG    0x1d
#define PX2080_KMB    0x1e
#define PX2080_RSV4   0x1f
#define PX2080_BXTL   0x20
#define PX2080_BXTH   0x21
#define PX2080_BYTL   0x22
#define PX2080_BYTH   0x23
#define PX2080_BXPL   0x24
#define PX2080_BXPH   0x25
#define PX2080_BYPL   0x26
#define PX2080_BYPH   0x27
#define PX2080_BXCL   0x28
#define PX2080_BXCH   0x29
#define PX2080_BYCL   0x2A
#define PX2080_BYCH   0x2B
#define PX2080_CXCL   0x2C
#define PX2080_CXCH   0x2D
#define PX2080_CYCL   0x2E
#define PX2080_CYCH   0x2F
#define PX2080_BIR_INDX   0x30


// Graphics overlay defines
#define GOC_GRAPHICS_ONLY 0x0
#define GOC_CHROMA_ONLY   0xaa
#define GOC_ZCODE_ONLY    0xf
#define GOC_CHROMA_AND_ZCODE    0xa

// Analog setup defines
#define ASC_NORMAL    0x80
#define ASC_24BIT   0x82
#define ASC_SYNC_ON_GRN   0x88
#define ASC_SYNC_ON_RED   0x84
#define ASC_SYNC_ON_BLUE  0x90
#define ASC_PEDESTAL_ENABLE   0xa0

// Graphics Format defines
#define GFC_1TO1_CLOCK    0x4
#define GFC_TRUE_COLOR    0x10

// Cursor Setup defines
#define CSC_NORMAL    0x0

// Video Format defines
#define VFC_GAMMA_DISABLE 0x10
#define VFC_YUV_422   0x0

// Chroma Key defines
#define BORLAND_FILL    0x7
#define WINDOWS_FILL    0x0

// Chroma Mask defines
#define NO_MASK     0xff

// Sync Align defines
#define SAR_HSIN_HI             0x80
#define SAR_VSIN_HI             0x20
#define SAR_NORMAL              0x0

// RSVD1 defines
#define PCLK2_OFF               0x10

// VAFC defines
#define VAFC_OFF                0x2
#define VAFC_32BIT_1X           0x8
#define VAFC_32BIT_2X           0xc
#define VAFC_16BIT_1X           0x0
#define VAFC_16BIT_2X           0x4

// GSR defines
#define PX2080DAC               0X00
#define PX2085DAC               0X80






#define GAMMA_ARRAY_SIZE        768
#define GAMMA_EN_MASK           0x10
#define VGA_ARRAY_SIZE          768







// typedefs ---------------------------------
typedef struct tagPX2080Ports
{                                 // ISA    MEMORY      LOCAL_IO
  unsigned long PX2080Bir;        // Bir    base port   0=4bit 1=5bit
  unsigned long PX2080Port0;      // Port0  offset      Port0
  unsigned long PX2080Port1;      // Port1              Port1
  unsigned long PX2080Port2;      // Port2              Port2
  unsigned long PX2080Port3;      // Port3              Port3
  unsigned long PX2080Port4;      //                    Port4
  unsigned long PX2080Port5;      //                    Port5
  unsigned long PX2080Port6;      //                    Port6
  unsigned long PX2080Port7;      //                    Port7
  unsigned long PX2080Port8;      //                    Port8
  unsigned long PX2080Port9;      //                    Port9
  unsigned long PX2080Port10;     //                    Port10
  unsigned long PX2080Port11;     //                    Port11
  unsigned long PX2080Port12;     //                    Port12
  unsigned long PX2080Port13;     //                    Port13
  unsigned long PX2080Port14;     //                    Port14
  unsigned long PX2080Port15;     //                    Port15
  unsigned long PX2080Port16;     //                    Port16
  unsigned long PX2080Port17;     //                    Port17
  unsigned long PX2080Port18;     //                    Port18
  unsigned long PX2080Port19;     //                    Port19
  unsigned long PX2080Port20;     //                    Port20
  unsigned long PX2080Port21;     //                    Port21
  unsigned long PX2080Port22;     //                    Port22
  unsigned long PX2080Port23;     //                    Port23
  unsigned long PX2080Port24;     //                    Port24
  unsigned long PX2080Port25;     //                    Port25
  unsigned long PX2080Port26;     //                    Port26
  unsigned long PX2080Port27;     //                    Port27
  unsigned long PX2080Port28;     //                    Port28
  unsigned long PX2080Port29;     //                    Port29
  unsigned long PX2080Port30;     //                    Port30
  unsigned long PX2080Port31;     //                    Port31
} PX2080Ports;

typedef struct tagPX2080InitParms
{
  unsigned char *pbColorPalette;
  unsigned char bPixelMaskReg;
  unsigned char *pbCursorPalette;
  unsigned char bAnalogSetupReg;
  unsigned char bGraphicsFormatReg;
  unsigned char bCursorSetupReg;
  unsigned char *pbCursorPattern;
  unsigned short wCursorXPos;
  unsigned short wCursorYPos;
  unsigned char bVideoFormatReg;
  unsigned char bGraphicsOvlyReg;
  unsigned char bSyncAlignReg;
  unsigned char bRSVD1Reg;
  unsigned char *pbGammaPalette;
  unsigned char bChromaKeyRedReg;
  unsigned char bChromaKeyGreenReg;
  unsigned char bChromaKeyBlueReg;
  unsigned char bChromaMaskRedReg;
  unsigned char bChromaMaskGreenReg;
  unsigned char bChromaMaskBlueReg;
} PX2080InitParms;


/* macros -----------------------------------------------*/
#define UNLOCK_MD_REGS       outw_p(0x0f,0x3ce); \
			     bVGALocked = inw_p(0x3cf); \
			     outw_p(0x05,0x3cf);  \
			     outw_p(0x10,0x3ce); \
			     bTemp = inw_p(0x3cf); \
			     outw_p((0x08|bTemp),0x3cf);

#define LOCK_MD_REGS         outw_p(0x10,0x3ce); \
			     bTemp = inw_p(0x3cf); \
			     outw_p((0xf7 & bTemp),0x3cf);\
			     outw_p(0x0f,0x3ce); \
			     outw_p(bVGALocked,0x3cf);


/* preprocessor definitions -----------------------------*/
#define CLUT_PIXEL_MASK   0x3c6
#define CLUT_READ_ADDRESS       0x3c7
#define CLUT_WRITE_ADDRESS      0x3c8
#define CLUT_COLOR_DATA         0x3c9

/* type definitions -------------------------------------*/
typedef struct {
    unsigned char Red;
    unsigned char Green;
    unsigned char Blue;
} RGBCOLOR, *FPRGBCOLOR;

/* function prototypes ----------------------------------*/
void  cpclut();
void    PutPx2080Clut(int index, FPRGBCOLOR fpRgb);
void    BeginCritical(void);
void    EndCritical(void);
void    GetVgaClut(int index, FPRGBCOLOR fpRgb);



// Prototypes -----------------------------------------------------

unsigned char IoInByteFunc(unsigned long dwPortAddress);
void IoOutByteFunc(unsigned long dwPortAddress,unsigned char bData);
unsigned char MemInByteFunc(unsigned long dwPortAddress);
void MemOutByteFunc(unsigned long dwPortAddress,unsigned char bData);
unsigned char ioMemPortReadMD(int iPort);
int ioMemPortWriteMD(int iPort,unsigned char bData);
unsigned char ioISAPortReadMD(int iPort);
int ioISAPortWriteMD(int iPort,unsigned char bData);
unsigned char ioPort5BitReadMD(int iPort);
int ioPort5BitWriteMD(int iPort,unsigned char bData);
void ioClear4BitBlockMD(void);
void ioSet4BitBlockMD(int iReg);
void cpclut(void);


int ioCrsrColorWriteMD(unsigned char bIndex,unsigned char *pbList,int iCount);
int ioCrsrColorReadMD(unsigned char bIndex,unsigned char *pbList,int iCount);
int ioCrsrPtrnWriteMD(unsigned char bIndex,unsigned char *pbList,int iCount);
int ioCrsrPtrnReadMD(unsigned char bIndex,unsigned char *pbList,int iCount);
unsigned char ioStatusReadMD(void);
void ioGraphicsFormatWriteMD(unsigned char bData);
unsigned char ioGraphicsFormatReadMD(void);
void ioPixelMaskWriteMD(unsigned char bData);
unsigned char ioPixelMaskReadMD(void);
void ioCrsrSetupWriteMD(unsigned char bData);
unsigned char ioCrsrSetupReadMD(void);
int ioGammaLutWriteMD(unsigned char bIndex,unsigned char *pbList,int iCount);
int ioGammaLutReadMD(unsigned char bIndex,unsigned char *pbList,int iCount);
int ioColorPaletteWriteMD(unsigned char bIndex,unsigned char *pbList,int iCount);
int ioColorPaletteReadMD(unsigned char bIndex,unsigned char *pbList,int iCount);
void ioGraphicsOvlyWriteMD(unsigned char bData);
unsigned char ioGraphicsOvlyReadMD(void);
void ioRedChromaKeyWriteMD(unsigned char bRedKey);
unsigned char ioRedChromaKeyReadMD(void);
void ioGreenChromaKeyWriteMD(unsigned char bGreenKey);
unsigned char ioGreenChromaKeyReadMD(void);
void ioBlueChromaKeyWriteMD(unsigned char bBlueKey);
unsigned char ioBlueChromaKeyReadMD(void);
void ioRedChromaMaskWriteMD(unsigned char bRedMask);
unsigned char ioRedChromaMaskReadMD(void);
void ioGreenChromaMaskWriteMD(unsigned char bGreenMask);
unsigned char ioGreenChromaMaskReadMD(void);
void ioBlueChromaMaskWriteMD(unsigned char bBlueMask);
unsigned char ioBlueChromaMaskReadMD(void);
void ioCrsrXPosWriteMD(unsigned short wXPos);
unsigned short ioCrsrXPosReadMD(void);
void ioCrsrYPosWriteMD(unsigned short wYPos);
unsigned short ioCrsrYPosReadMD(void);
void ioVideoFormatWriteMD(unsigned char bData);
unsigned char ioVideoFormatReadMD(void);
void ioSyncAlignWriteMD(unsigned char bData);
unsigned char ioSyncAlignReadMD(void);
void ioComReg3WriteMD(unsigned char bData);
unsigned char ioComReg3ReadMD(void);
void ioAnalogSetupWriteMD(unsigned char bData);
unsigned char ioAnalogSetupReadMD(void);
int ioSetCurrentMD(int iProc);
int ioGetCurrentMD(void);
void ioSetBIRBlockMD(unsigned char bData);
void ioBIRWriteMD(unsigned char bBirVal);
unsigned char ioBIRReadMD(void);
int ioPortWriteMD(int iPortVal, unsigned char bData);
unsigned char ioPortReadMD(int iPortVal);
int ioInitMD(PX2080InitParms *pInitStruct);
unsigned char ioRSV1ReadMD(void);
void ioRSV1WriteMD(unsigned char);
unsigned char ioRSV2ReadMD(void);
void ioRSV2WriteMD(unsigned char);
unsigned char ioRSV3ReadMD(void);
void ioRSV3WriteMD(unsigned char);
unsigned char ioRSV4ReadMD(void);
void ioRSV4WriteMD(unsigned char);
unsigned char ioCrsrXLowPosReadMD(void);
void ioCrsrXLowPosWriteMD(unsigned char);
unsigned char ioCrsrXHiPosReadMD(void);
void ioCrsrXHiPosWriteMD(unsigned char);
unsigned char ioCrsrYLowPosReadMD(void);
void ioCrsrYLowPosWriteMD(unsigned char);
unsigned char ioCrsrYHiPosReadMD(void);
void ioCrsrYHiPosWriteMD(unsigned char);
unsigned char ioVAFCReadMD(void);
void ioVAFCWriteMD(unsigned char);
unsigned char ioBXTLReadMD(void);
void ioBXTLWriteMD(unsigned char);
unsigned char ioBXTHReadMD(void);
void ioBXTHWriteMD(unsigned char);
unsigned char ioBYTLReadMD(void);
void ioBYTLWriteMD(unsigned char);
unsigned char ioBYTHReadMD(void);
void ioBYTHWriteMD(unsigned char);
unsigned char ioBXPLReadMD(void);
void ioBXPLWriteMD(unsigned char);
unsigned char ioBXPHReadMD(void);
void ioBXPHWriteMD(unsigned char);
unsigned char ioBYPLReadMD(void);
void ioBYPLWriteMD(unsigned char);
unsigned char ioBYPHReadMD(void);
void ioBYPHWriteMD(unsigned char);
unsigned char ioBXCLReadMD(void);
void ioBXCLWriteMD(unsigned char);
unsigned char ioBXCHReadMD(void);
void ioBXCHWriteMD(unsigned char);
unsigned char ioBYCLReadMD(void);
void ioBYCLWriteMD(unsigned char);
unsigned char ioBYCHReadMD(void);
void ioBYCHWriteMD(unsigned char);
unsigned char ioCXCLReadMD(void);
void ioCXCLWriteMD(unsigned char);
unsigned char ioCXCHReadMD(void);
void ioCXCHWriteMD(unsigned char);
unsigned char ioCYCLReadMD(void);
void ioCYCLWriteMD(unsigned char);
unsigned char ioCYCHReadMD(void);
void ioCYCHWriteMD(unsigned char);
unsigned char ioCAWReadMD(void);
void ioCAWWriteMD(unsigned char);
unsigned char ioCARReadMD(void);
void ioCARWriteMD(unsigned char);
unsigned char ioVGWReadMD(void);
void ioVGWWriteMD(unsigned char);
unsigned char ioVGRReadMD(void);
void ioVGRWriteMD(unsigned char);
#endif /* __MD_KEYWORD__
/*********************/
