/* $Id: poke.c,v 1.7 1997/03/09 06:52:10 todd Exp $ */
#include <asm/io.h>
#include <stdio.h>
#include <errno.h>

#include <vga.h>
#include <vgagl.h>
#undef UNDEFINED

#include "i2capi.h"
#include "px2070.h"
#include "evalprot.h"
#include "evaldiag.h"
#include "vhf_uhf.h"
#include "catv1.h"
#include "catv2.h"

#define TUNER_MASK 0x42

float *fPictureIF = &catv1_picture_if;

float *fChannels = catv1_channels;
int *iMinChannel = &catv1_min_channel;
int *iMaxChannel = &catv1_max_channel;

int iCurrentChannel;

unsigned short RS0=0x100, RS1=0x8000;
unsigned short tmp;
extern void *G_pvConfigArray[MAXCONFIGARRAY];

int main (int argc,char *argv[])

{
	unsigned short v;
	float fTemp;
	int i,j,k,iData=0;
	if(iopl(3))
	{ printf("Error with iopl. Must be suid root or run as root.\n");
          return(-1);
        }
        if (argc != 4)
         {
          if (argc == 2 && atoi(argv[1]) == 0)
          {
          }
          else
          {
             printf("usage: stv input band initial_channel\n");
             printf("where: input is 0 for RCA and 1 for COAX\n");
             printf("       band is 0 for VFH/UHF, 1 for CATV1, 2 for CATV2\n");
             printf("       initial channel is between the minimum and maximum for the band\n");
             return(0);
          }
         }
	OpenPX(); /* Read conf file for ports */
	printf("Testing PX0001 Register tests\n");
	Test0001Regs(0);
	if(G_pvConfigArray[VIDMODBASE]!=NULL)
	{
		printf("Executing 9051 Tests \n");
		ioInitVid(NULL);
		printf("Executing Tuner Tests\n");
		ioInitTuner(NULL);
	}
	InitPx0001();
	/* Select the 1085 graphics source */
        if (atoi(argv[1]) == 0 || atoi(argv[1]) == 1)
        {
	   ioInitVid(NULL);
	   ioSetVidChannel(atoi(argv[1]));
	   ioInitTuner();
           SetAudioSource(atoi(argv[1]));
        }
        else
        {
           printf("Input must be 0 for RCA and 1 for COAX\n");
           return(0);
        }
        SetAudioMute(AUDIO_ON);
        if (atoi(argv[1]) == 1)
        {
           switch (atoi(argv[2]))
           {
              case 0:    fPictureIF = &vhf_uhf_picture_if;
                         fChannels = vhf_uhf_channels;
                         iMinChannel = &vhf_uhf_min_channel;
                         iMaxChannel = &vhf_uhf_max_channel;
                         break;
              case 1:    fPictureIF = &catv1_picture_if;
                         fChannels = catv1_channels;
                         iMinChannel = &catv1_min_channel;
                         iMaxChannel = &catv1_max_channel;
                         break;
              case 2:    fPictureIF = &catv2_picture_if;
                         fChannels = catv2_channels;
                         iMinChannel = &catv2_min_channel;
                         iMaxChannel = &catv2_max_channel;
                         break;
           }
           if (atoi(argv[3]) >= *iMinChannel && atoi(argv[3]) <= *iMaxChannel)
           {
              iCurrentChannel = atoi(argv[3]); /* get channel from command line */
              fTemp = fChannels[iCurrentChannel]; /* convert to freq */
              printf("Channel: %d\n",iCurrentChannel);
              tnrChangeChannel((float *)&fTemp,(char)0,(float *) fPictureIF);
           }
           else
           {
              printf("The initial channel must be between %d and %d for this band\n",*iMinChannel,*iMaxChannel);
              SetAudioMute(AUDIO_MUTE);
              return(0);
           }
        }
        /* Scans the Channels */
        /*
	for(i=0;i<MAX_CHANNELS;i++)
        {
          for (j=0;j<MAX_STANDARDS;j++)
          {
            fTemp = G_fChanFreq[i][j];
            printf("Channel: %d Standard: %d\n",i,j);
            tnrChangeChannel((float *)&fTemp,(char)0,(float *) &G_fPictureIF);
	sleep(3);
            DrvVidModRead((LPVOID)&iData) ;
            iData&=0x40;
          }
        }
        */
        /* Select the 1085 graphics source */
        SetGraphicsSource(PX1085_GRAPHICS); 
        PIPDemo(fChannels, fPictureIF,(int) *iMinChannel, (int) *iMaxChannel,iCurrentChannel);
        SetAudioMute(AUDIO_MUTE);
        /* Select the VGA graphics source */
        SetGraphicsSource(VGA_GRAPHICS); 
	
	Show_Gate();

	return;
}
