// $Id: poke.h,v 1.2 1997/03/03 03:24:05 todd Exp $ 

#ifdef DEBUG
#undef inb
#undef outb
#undef inw
#undef outw
#undef outw_p
#undef inw_p
#undef outb_p
#undef inb_p
#undef iopl

#define inb(x)	printf("inb(0x%x)\n",x);
#define inb_p(x) printf("inb_p(0x%x)\n",x);
#define inw(x)  printf("inw(0x%x)\n",x);
#define inw_p(x) printf("inw_p(0x%x)\n",x);
#define outb(x,y) printf("outb(0x%x,0x%x)\n",x,y);
#define outb_p(x,y) printf("outb_p(0x%x,0x%x)\n",x,y);
#define outw(x,y) printf("outw(0x%x,0x%x)\n",x,y);
#define outw_p(x,y) printf("outw_p(0x%x,0x%x)\n",x,y);
#define iopl
#endif

extern unsigned short RS0, RS1;
unsigned short tmp;   /* to prevent overhead in 'allocation' every
		       * time a function uses it  (NOT to be used outside the
		       * scope of any function, NOT to be used in a function
		       * that calls another)
		       */

#define BOOL int

#define FALSE (0)
#define TRUE (!(FALSE))

#define Gi (RS0 + RS1 + 0x270)
#define Gd (Gi + 2)

/* MISC Register values */

#define MISC_AU_SRC (1<<15)   /* audio source. 0=external audio */
#define MISC_GR     (1<<14)   /* video source. 0=external video */
#define MISC_PCLK   (1<<13)   /* PCLK speed selection. 0=MCLK/2. 1=MCLK/3. */
#define MISC_MUTE   (1<<12)   /* 0=muted audio */
#define MISC_1085   (1<<11)   /* 1085 VGA address read enable. 0=disable */
#define MISC_PCLK_O (1<<10)   /* Enable PCLK output pin to toggle. 0=disable */
#define MISC_MCLK_O (1<<9)    /* Enable MCLK output pin to toggle. 0=disable */
#define MISC_VICLK  (1<<8)    /* Enable inverting VICLK. 0=noninverting */
#define MISC_BLOCK  (0xf<<3)  /* Specifies upper 4 bits of ISA bus address or
				 BLOCK for other register */
#define MISC_IRQ    (7)       /* Speciies IRQ line. 5, 6, or 7 = IRQ disabled */

struct Gate {
	unsigned short Addr_2070[4];  /* index 0-4 */
	unsigned short I2C_Port;      /* index 5 */
	unsigned short MISCr;         /* index 6 */
	unsigned short Addr_2085;     /* index 7 */
	unsigned short stat[8];       /* index 8-15 */
};

/***********************
 * Function Prototypes * 
 ***********************/

/* setup.c */
void Show_Gate(void);
void set_MISC_base(unsigned short v);
void set_1070_ports(unsigned short p0,unsigned short p1,unsigned short p2,unsigned short p3,unsigned short p4);
void set_1085_ports(unsigned short p0);
void vga_on(void);
void show_1070(void);

/* test2080.c */
void Test2080GammaPalette();
void Test2080ColorPalette();

/* iodvp.c */
unsigned short loc_DVP(char reg);

