
#ifndef __XR_TEST__
#include <asm/io.h>
#endif

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <fcntl.h>

#ifndef __XR_TEST__
#include <linux/soundcard.h>

#include "evaldiag.h"
#include "evalprot.h"
#include "i2capi.h"
#include "px2070.h"
#endif

#include "vhf_uhf.h"
#include "catv1.h"
#include "catv2.h"

#include "xr.h"
#include "tv_image.h"

#define TUNER_MASK 0x42

float fPictureIF;
float *fChannels;
int iMinChannel;
int iMaxChannel;
int iCurrentChannel = 3;

int iCurrentVolume = 15;
int iMinVolume = 0;
int iMaxVolume = 100;

int iFrozen = 0;
int iImageDepth = 0;

FD_remote2 * form0;
char Buffer[20];
char Position=0;
char Mutebuffer[5]="85%";

int remote_setup()
{
	/* this really should be somewhere else probably */
	fPictureIF = vhf_uhf_picture_if;
	fChannels = vhf_uhf_channels;
	iMinChannel = vhf_uhf_min_channel;
	iMaxChannel = vhf_uhf_max_channel;

	/* now actually create remote */
    form0 = create_form_remote2();

    /* Set some stuff up */
    fl_set_object_bw(form0->but_1,-2);
    fl_set_object_bw(form0->but_2,-2);
    fl_set_object_bw(form0->but_3,-2);
    fl_set_object_bw(form0->but_4,-2);
    fl_set_object_bw(form0->but_5,-2);
    fl_set_object_bw(form0->but_6,-2);
    fl_set_object_bw(form0->but_7,-2);
    fl_set_object_bw(form0->but_8,-2);
    fl_set_object_bw(form0->but_9,-2);
    fl_set_object_bw(form0->but_0,-2);
    fl_set_object_bw(form0->but_help,-2);
    fl_set_object_bw(form0->but_mute,-2);
    fl_set_object_bw(form0->but_style,-2);
    fl_set_object_bw(form0->but_settings,-2);
    fl_set_object_bw(form0->power,-2);
    fl_set_object_bw(form0->channel_up,-2);
    fl_set_object_bw(form0->channel_down,-2);
    fl_set_object_bw(form0->volume_down,-2);
    fl_set_object_bw(form0->volume_up,-2);
    fl_set_object_bw(form0->but_capture,-2);

    fl_set_pixmapbutton_data(form0->power,power);
    fl_show_form(form0->remote2,FL_PLACE_FREE,FL_FULLBORDER,"X-Remote");

	return( 1 );
}

/***********
Key Pad
************/
void call_keypad(FL_OBJECT *obj, long arg)  
{
#ifdef __XR_TEST__
	printf( "call_keypad( '%c' )\n", obj->label[0] );
#endif

	if ( Position==0 )
	{
		fl_set_timer(form0->xtimer,2.0);
	}  

	form0->channel_text->label[Position]=obj->label[0];
	form0->channel_text->label[Position+1]=0;         
	Position++;
	fl_redraw_object(form0->channel_text);        

	if( Position == 3 )
		call_xtimer(obj,arg);
}

/*************
Timer
Channel Will Be Set Here
for virtual KeyPad Presses
or it can be set in the channel +/- buttons
*************/
void call_xtimer(FL_OBJECT *obj, long arg) 
{
	int temp;
	float fTemp;
	fl_set_timer(form0->xtimer,0.0);
	Position=0;

	iCurrentChannel = atoi( form0->channel_text->label );

	if ( iCurrentChannel > iMaxChannel )
		iCurrentChannel = iMaxChannel;

	if ( iCurrentChannel < iMinChannel )
		iCurrentChannel = iMinChannel;

	sprintf(form0->channel_text->label, "%d", iCurrentChannel );
	fl_redraw_object( form0->channel_text );

#ifdef __XR_TEST__
	printf( "call_xtimer(): iCurrenChannel now %d\n", iCurrentChannel );
#else
	fTemp=fChannels[iCurrentChannel];
        tnrChangeChannel((float *)&fTemp,(char)0,(float *) &fPictureIF);
#endif
}

/************
Mute
************/
void call_mute(FL_OBJECT *obj, long arg)   
{
	float fTemp;
	if ( (strcmp(form0->volume_text->label,"Mute")) )
	{
		strcpy(Mutebuffer,form0->volume_text->label);
		strcpy(form0->volume_text->label,"Mute");
		SetAudioMute(AUDIO_MUTE); 
	} else {
		strcpy(form0->volume_text->label,Mutebuffer);
		SetAudioMute(AUDIO_ON);
	}
	fl_redraw_object(form0->volume_text);   
}

/************
Power
************/      
void call_power(FL_OBJECT *obj, long arg)
{
#ifdef __XR_TEST__
	printf( "call_power()\n" );
#endif

	SetAudioMute(AUDIO_MUTE);

	tv_destroy();

	exit(1);
}

void set_channel()
{
	float fTemp;

	if ( iCurrentChannel > iMaxChannel )
		iCurrentChannel = iMinChannel;

	if ( iCurrentChannel < iMinChannel )
		iCurrentChannel = iMaxChannel;

	sprintf(form0->channel_text->label,"%02d", iCurrentChannel);
	fl_redraw_object(form0->channel_text);

#ifdef __XR_TEST__
	printf( "set_channel(): iCurrentChannel now %d\n", iCurrentChannel );
#else
	fTemp=fChannels[ iCurrentChannel ];
	tnrChangeChannel((float *)&fTemp,(char)0,(float *) &fPictureIF);
#endif
}

/**********
Increase Channel
**********/
void call_channel_up(FL_OBJECT *obj, long arg)
{
	set_channel( ++iCurrentChannel );
}

/**********
Decrease Channel
**********/
void call_channel_down(FL_OBJECT *obj, long arg)
{
	set_channel( --iCurrentChannel );
}

void set_volume()
{
	int		mixer_fd;
	int		mix_volume;


	if ( iCurrentVolume < iMinVolume )
		iCurrentVolume = iMinVolume;

	if ( iCurrentVolume > iMaxVolume )
		iCurrentVolume = iMaxVolume;

	sprintf(form0->volume_text->label, "%d%%", iCurrentVolume );
	fl_redraw_object(form0->volume_text);              

#ifdef __XR_TEST__
	printf( "set_volume(): iCurrentVolume now %d\n", iCurrentVolume );
#else
	mixer_fd = open( "/dev/mixer", O_RDWR );
	if ( mixer_fd < 0 )
	{
		perror( "set_volume" );
		return;
	}

	mix_volume = iCurrentVolume * 2.5;

	if ( ioctl( mixer_fd, MIXER_WRITE( SOUND_MIXER_VOLUME ), &mix_volume ) < 0 )
	{
		perror( "set_volume" );
	}

	close( mixer_fd );
#endif
}

/**************
Increase Volume
***************/
void call_volume_up(FL_OBJECT *obj, long arg)                
{
	iCurrentVolume += 5;
	set_volume( iCurrentVolume );
}

/*************
Decrease Volume 
**************/
void call_volume_down(FL_OBJECT *obj, long arg)
{
	iCurrentVolume -= 5;
	set_volume( iCurrentVolume );
}


void call_capture(FL_OBJECT *obj, long arg)
{
	const char *str;
	char	filename[ 251 ];
	FILE	*output;


#ifdef __XR_TEST__
	printf( "call_capture()\n" );
#endif

	strncpy( filename, ( str = fl_show_input( "Save Capture as:", "test.ppm" ))
		? str : "", 250 );
	filename[ 250 ] = '\0';

#ifdef __XR_TEST__
	printf( "  Capture to '%s'.\n", filename );
#endif

	if ( filename[ 0 ] == '\0' )
		return;

	output = fopen( filename, "w" );

	if ( output == NULL )
	{
		fl_show_message( "ERROR: unable to open capture file:", "", filename );
		return;
	}
	else
	{
		long i;

		printf( "capture depth = %d\n", iImageDepth );

		switch( iImageDepth )
		{
			case  8: 	fprintf( output, "P6\n%d %d 7\n", iWidth, iHeight );
						break;
			case 16: 	fprintf( output, "P6\n%d %d 63\n", iWidth, iHeight );
						break;
			case 24:	fprintf( output, "P6\n%d %d 255\n", iWidth, iHeight );
						break;
		}

		for ( i = 0; i < iWidth * iHeight ; i++ )
		{
			switch ( iImageDepth )
			{
				case  8:
						fputc( (char)((cap_buf[i] & 0xe0) >> 5 ), output ); 
						fputc( (char)((cap_buf[i] & 0x1c) >> 2 ), output );
						fputc( (char)((cap_buf[i] & 0x03) >> 0 ), output );
						break;

				case 16:
						fputc( (char)((cap_buf[i] & 0xf800) >> 10 ), output ); 
						fputc( (char)((cap_buf[i] & 0x07c0) >> 5 ), output );
						fputc( (char)((cap_buf[i] & 0x001f) << 1 ), output );
						break;
			}
		}

		fclose( output );
	}
}

void call_freeze(FL_OBJECT *obj, long arg)
{
	iFrozen = iFrozen ? 0 : 1;

#ifdef __XR_TEST__
	printf( "call_freeze(): iFrozen now %d\n", iFrozen );
#else
	capture_and_paste();
#endif
}

void call_settings(FL_OBJECT *obj, long arg)
{
#ifdef __XR_TEST__
	printf( "call_settings()\n" );
#else
	unsigned short tmp_buf[ 2000 ];
	int	i;

	memcpy( tmp_buf, &cap_buf[ ( iHeight - 1 ) * iWidth ],
		sizeof( unsigned short ) * iWidth );

	for ( i = iHeight - 1; i > 0 ; i-- )
		memcpy( &cap_buf[ i * iWidth ],
			&cap_buf[ ( i - 1 ) * iWidth ], sizeof( unsigned short ) * iWidth );

	memcpy( cap_buf, tmp_buf, sizeof( unsigned short ) * iWidth );

	refresh_image();
#endif
}

void call_style(FL_OBJECT *obj, long arg)
{
#ifdef __XR_TEST__
	printf( "call_style()\n" );
#else
	unsigned short tmp_pix;
	int i, j;

	for ( i = 0; i < iHeight; i++ )
	{	
		tmp_pix = cap_buf[ ( i * iWidth ) + iWidth - 1 ];
		/*
		memcpy( &cap_buf[ ( i * iWidth ) ],
			&cap_buf[ ( i * iWidth ) - 1 ],
			sizeof( unsigned short ) * ( iWidth - 1 ));
		*/
		for( j = iWidth; j > 0; j-- )
		{
			cap_buf[ ( i * iWidth ) + j ] =
				cap_buf[ ( i * iWidth ) + j - 1 ];
		}
		cap_buf[ ( i * iWidth ) ] = tmp_pix;
	}

	refresh_image();
#endif
}

void call_help(FL_OBJECT *obj, long arg)
{
#ifdef __XR_TEST__
	printf( "call_help()\n" );
#else
	static int channel = 0;

	if ( channel == 0 )
		channel = 1;
	else
		channel = 0;

	ioSetVidChannel( channel );
	SetAudioSource( channel );
#endif
}

