#include <asm/io.h>
#include <strings.h>
#include "poke.h"
#include "px2080.h"

#define MAXPATTERNS 20

/* Global test pattern array */
unsigned char G_bTestPats[MAXPATTERNS] = {0xff,0xaa,0x55,
			     0x01,0x02,0x04,0x08,
			     0x10,0x20,0x40,0x80,
			     0xfe,0xfd,0xfb,0xf7,
			     0xef,0xdf,0xbf,0x7f,0x00};

void Test2080Regs()
{
unsigned char bMaskArray[MAX2080REGS] = {
        LAW_MASK,LCD_MASK,LPM_MASK,LAR_MASK,
        CAW_MASK,CCD_MASK,ASC_MASK,CAR_MASK,
        GFC_MASK,CSC_MASK,GSR_MASK,CPR_MASK,
        CXL_MASK,CXH_MASK,CYL_MASK,CYH_MASK,
        VFC_MASK,GOC_MASK,SAR_MASK,RSV1_MASK,
        VGW_MASK,VGD_MASK,RSV2_MASK,VGR_MASK,
        CKR_MASK,CKG_MASK,CKB_MASK,RSV3_MASK,
        KMR_MASK,KMG_MASK,KMB_MASK,RSV4_MASK};
      /*        BXTL_MASK,BXTH_MASK,BYTL_MASK,BYTH_MASK, */
      /*        BXPL_MASK,BXPH_MASK,BYPL_MASK,BYPH_MASK, */
      /*        BIR_MASK}; */

char *pcFailStringArray[MAX2080REGS] = {
        "LAW","LCD","LPM","LAR",
        "CAW","CCD","ASC","CAR",
        "GFC","CSC","GSR","CPR",
        "CXL","CXH","CYL","CYH",
        "VFC","GOC","SAR","RSV1",
        "VGW","VGD","RSV2","VGR",
        "CKR","CKG","CKB","RSV3",
        "KMR","KMG","KMB","RSV4"};
    /*  "BXTL","BXTH","BYTL","BYTH", */
    /*  "BXPL","BXPH","BYPL","BYPH", */
    /*  "BIR"}; */
int i,j;
unsigned char bWriteVal,bReadVal;

/******************************************
* Test each register with unique data
*******************************************/

/* Write the data */
for (i=8;i<MAX2080REGS-1;i++)
  {
  switch(i)
    {
    case 0:

      break;
    case 1:
      /* Test this quy later */
      break;
    case 2:

      break;
    case 3:

      break;
    case 4:

      break;
    case 5:
      /* Test this guy later */
      break;
    case 6:

      break;
    case 7:

      break;
    case 8:
      ioGraphicsFormatWriteMD(i & bMaskArray[i]);
      break;
    case 9:
      ioCrsrSetupWriteMD(i & bMaskArray[i]);
      break;
    case 10:
      /* Read only */
      break;
    case 11:
      /* Test this quy later */
      break;
    case 12:
      ioCrsrXLowPosWriteMD(i & bMaskArray[i]);
      break;
    case 13:
      ioCrsrXHiPosWriteMD(i & bMaskArray[i]);
      break;
    case 14:
      ioCrsrYLowPosWriteMD(i & bMaskArray[i]);
      break;
    case 15:
      ioCrsrYHiPosWriteMD(i & bMaskArray[i]);
      break;
    case 16:
      ioVideoFormatWriteMD(i & bMaskArray[i]);
      break;
    case 17:
      ioGraphicsOvlyWriteMD(i & bMaskArray[i]);
      break;
    case 18:
      ioSyncAlignWriteMD(i & bMaskArray[i]);
      break;
    case 19:
      ioRSV1WriteMD(i & bMaskArray[i]);
      break;
    case 20:
      ioVGWWriteMD(i & bMaskArray[i]);
      break;
    case 21:
      /* Test this guy later */
      break;
    case 22:
      ioRSV2WriteMD(i & bMaskArray[i]);
      break;
    case 23:
      ioVGRWriteMD(i & bMaskArray[i]);
      break;
    case 24:
      ioRedChromaKeyWriteMD(i & bMaskArray[i]);
      break;
    case 25:
      ioGreenChromaKeyWriteMD(i & bMaskArray[i]);
      break;
    case 26:
      ioBlueChromaKeyWriteMD(i & bMaskArray[i]);
      break;
    case 27:
      ioRSV3WriteMD(i & bMaskArray[i]);
      break;
    case 28:
      ioRedChromaMaskWriteMD(i & bMaskArray[i]);
      break;
    case 29:
      ioGreenChromaMaskWriteMD(i & bMaskArray[i]);
      break;
    case 30:
      ioBlueChromaMaskWriteMD(i & bMaskArray[i]);
      break;
    case 31:
      ioRSV4WriteMD(i & bMaskArray[i]);
      break;


    } /* Switch */
  } /* for */

/* Read the data */
for (i=8;i<MAX2080REGS-1;i++)
  {
  switch(i)
    {
    case 0:

      break;
    case 1:
      /* Test this guy later */
      break;
    case 2:

      break;
    case 3:

      break;
    case 4:

      break;
    case 5:
      /* Test this guy later */
      break;
    case 6:

      break;
    case 7:

      break;
    case 8:
      bReadVal = ioGraphicsFormatReadMD();
      break;
    case 9:
      bReadVal = ioCrsrSetupReadMD();
      break;
    case 10:
      /* Read only */
      break;
    case 11:
      /* Test this guy later */

      break;
    case 12:
      bReadVal = ioCrsrXLowPosReadMD();
      break;
    case 13:
      bReadVal = ioCrsrXHiPosReadMD();
      break;
    case 14:
      bReadVal = ioCrsrYLowPosReadMD();
      break;
    case 15:
      bReadVal = ioCrsrYHiPosReadMD();
      break;
    case 16:
      bReadVal = ioVideoFormatReadMD();
      break;
    case 17:
      bReadVal = ioGraphicsOvlyReadMD();
      break;
    case 18:
      bReadVal = ioSyncAlignReadMD();
      break;
    case 19:
      bReadVal = ioRSV1ReadMD();
      break;
    case 20:
      bReadVal = ioVGWReadMD();
      break;
    case 21:
      /* Test this guy later */
      break;
    case 22:
      bReadVal = ioRSV2ReadMD();
      break;
    case 23:
      bReadVal = ioVGRReadMD();
      break;
    case 24:
      bReadVal = ioRedChromaKeyReadMD();
      break;
    case 25:
      bReadVal = ioGreenChromaKeyReadMD();
      break;
    case 26:
      bReadVal = ioBlueChromaKeyReadMD();
      break;
    case 27:
      bReadVal = ioRSV3ReadMD();
      break;
    case 28:
      bReadVal = ioRedChromaMaskReadMD();
      break;
    case 29:
      bReadVal = ioGreenChromaMaskReadMD();
      break;
    case 30:
      bReadVal = ioBlueChromaMaskReadMD();
      break;
    case 31:
      bReadVal = ioRSV4ReadMD();
      break;

    } /* Switch */

  /* Skip the registers not tested */
  if (i==5 | i==6 | i==0xa | i==0xb | i==0x15 )
    continue;

  /* Is what you read what you wrote? */
  if ((bReadVal & bMaskArray[i]) != (i & bMaskArray[i]))
    {
    printf("%s READ ERROR Expected %02x Actual %02x\n",pcFailStringArray[i],(i&bMaskArray[i]),bReadVal);
    }
  } /* for */

/******************************************
* Test each register with the test array data
*******************************************/

/* Write the data */
for (i=8;i<MAX2080REGS-1;i++)
  {
  /* Skip the registers not tested */
  if (i==5 || i==6 || i== 9 || i==0xa || i==0xb || i==0x15 )
    {
    continue;
    }
  for (j=0;j<MAXPATTERNS;j++)
    {
    switch(i)
      {
      case 0:

        break;
      case 1:
        /* Test this quy later */
        break;
      case 2:

        break;
      case 3:

        break;
      case 4:

        break;
      case 5:
        /* Test this guy later */
        break;
      case 6:

        break;
      case 7:

        break;
      case 8:
        ioGraphicsFormatWriteMD(G_bTestPats[j] & bMaskArray[i]);
        break;
      case 9:
        ioCrsrSetupWriteMD(G_bTestPats[j] & bMaskArray[i]);
        break;
      case 10:
        /* Read only */
        break;
      case 11:
        /* Test this quy later */
        break;
      case 12:
        ioCrsrXLowPosWriteMD(G_bTestPats[j] & bMaskArray[i]);
        break;
      case 13:
        ioCrsrXHiPosWriteMD(G_bTestPats[j] & bMaskArray[i]);
        break;
      case 14:
        ioCrsrYLowPosWriteMD(G_bTestPats[j] & bMaskArray[i]);
        break;
      case 15:
        ioCrsrYHiPosWriteMD(G_bTestPats[j] & bMaskArray[i]);
        break;
      case 16:
        ioVideoFormatWriteMD(G_bTestPats[j] & bMaskArray[i]);
        break;
      case 17:
        ioGraphicsOvlyWriteMD(G_bTestPats[j] & bMaskArray[i]);
        break;
      case 18:
        ioSyncAlignWriteMD(G_bTestPats[j] & bMaskArray[i]);
        break;
      case 19:
        ioRSV1WriteMD(G_bTestPats[j] & bMaskArray[i]);
        break;
      case 20:
        ioVGWWriteMD(G_bTestPats[j] & bMaskArray[i]);
        break;
      case 21:
        /* Test this guy later */
        break;
      case 22:
        ioRSV2WriteMD(G_bTestPats[j] & bMaskArray[i]);
        break;
      case 23:
        ioVGRWriteMD(G_bTestPats[j] & bMaskArray[i]);
        break;
      case 24:
        ioRedChromaKeyWriteMD(G_bTestPats[j] & bMaskArray[i]);
        break;
      case 25:
        ioGreenChromaKeyWriteMD(G_bTestPats[j] & bMaskArray[i]);
        break;
      case 26:
        ioBlueChromaKeyWriteMD(G_bTestPats[j] & bMaskArray[i]);
        break;
      case 27:
        ioRSV3WriteMD(G_bTestPats[j] & bMaskArray[i]);
        break;
      case 28:
        ioRedChromaMaskWriteMD(G_bTestPats[j] & bMaskArray[i]);
        break;
      case 29:
        ioGreenChromaMaskWriteMD(G_bTestPats[j] & bMaskArray[i]);
        break;
      case 30:
        ioBlueChromaMaskWriteMD(G_bTestPats[j] & bMaskArray[i]);
        break;
      case 31:
        ioRSV4WriteMD(G_bTestPats[j] & bMaskArray[i]);
        break;

      } /* Switch */


/* Read the data */

    switch(i)
      {
      case 0:

        break;
      case 1:
        /* Test this guy later */
        break;
      case 2:

        break;
      case 3:

        break;
      case 4:

        break;
      case 5:
        /* Test this guy later */
        break;
      case 6:

        break;
      case 7:

        break;
      case 8:
        bReadVal = ioGraphicsFormatReadMD();
        break;
      case 9:
        bReadVal = ioCrsrSetupReadMD();
        break;
      case 10:
        /* Read only */
        break;
      case 11:
        /* Test this guy later */
        break;
      case 12:
        bReadVal = ioCrsrXLowPosReadMD();
        break;
      case 13:
        bReadVal = ioCrsrXHiPosReadMD();
        break;
      case 14:
        bReadVal = ioCrsrYLowPosReadMD();
        break;
      case 15:
        bReadVal = ioCrsrYHiPosReadMD();
        break;
      case 16:
        bReadVal = ioVideoFormatReadMD();
        break;
      case 17:
        bReadVal = ioGraphicsOvlyReadMD();

        break;
      case 18:
        bReadVal = ioSyncAlignReadMD();
        break;
      case 19:
        bReadVal = ioRSV1ReadMD();
        break;
      case 20:
        bReadVal = ioVGWReadMD();
        break;
      case 21:
        /* Test this guy later */
        break;
      case 22:
        bReadVal = ioRSV2ReadMD();
        break;
      case 23:
        bReadVal = ioVGRReadMD();
        break;
      case 24:
        bReadVal = ioRedChromaKeyReadMD();
        break;
      case 25:
        bReadVal = ioGreenChromaKeyReadMD();
        break;
      case 26:
        bReadVal = ioBlueChromaKeyReadMD();
        break;
      case 27:
        bReadVal = ioRSV3ReadMD();
        break;
      case 28:
        bReadVal = ioRedChromaMaskReadMD();
        break;
      case 29:
        bReadVal = ioGreenChromaMaskReadMD();
        break;
      case 30:
        bReadVal = ioBlueChromaMaskReadMD();
        break;
      case 31:
        bReadVal = ioRSV4ReadMD();
        break;


      } /* Switch */
    /* Is what you read what you wrote? */
    if ((bReadVal & bMaskArray[i]) != (G_bTestPats[j] & bMaskArray[i]))
      {
      printf("%s READ ERROR Expected %02x Actual %02x\n",pcFailStringArray[i],(G_bTestPats[j]&bMaskArray[i]),bReadVal);
      }
    } /* for j */
  } /* for i */
/* init 2080 */
ioInitMD(NULL);

} /* End Test2080Regs */


/**********************************************************
*
*       File Name:  Test2080.c
*
*       Module Abstract: This module tests the Gamma palette.
*
*       Calling Sequence:
*               Test2080GammaPalette();
*
*       Input Parameters:
*               none
*
*       Output Parameters:
*               none
*
*       Global Variables:
*       G_bTestPats[MAXPATTERNS]
***********************************************************
*       Author: Kyle Pratt
*       Date:   1/28/93
*
*       Revision History:
*       WHO             WHEN            WHAT/WHY/HOW
*
*
*********************************************************/

void Test2080GammaPalette()
{
int i,j,iCount=0,k,n;
unsigned char bWriteVal,bReadVal;
unsigned char bWriteArray[256][3];
unsigned char bReadArray[256][3];

/****************************************************
* Test the gamma palette with address dependent data
*****************************************************/
for (i=0;i<256;i++)
  {
  for (j=0;j<3;j++)
    {
    bWriteArray[i][j] = iCount;
    iCount++;
    }
  }
ioGammaLutWriteMD(0,(unsigned char *) bWriteArray,768);

/****************************************
* Read back the data
****************************************/
ioGammaLutReadMD(0,(unsigned char *) bReadArray,768);

/* Is what you read what you wrote? */
for (i=0;i<256;i++)
  {
  for (j=0;j<3;j++)
    {

    if (bReadArray[i][j] != bWriteArray[i][j])
      {
      printf("GAMMA PALETTE READ ERROR  Location %x, %x Expected %02x Actual %02x\n",
	     i,j,bWriteArray[i][j],bReadArray[i][j]);
      }
    } /* for j */
  } /* for i */

/****************************************************
* Test the gamma palette with the test array data
*****************************************************/
for (n=0;n<MAXPATTERNS;n++)
  {
  for (i=0;i<256;i++)
    {
    for (j=0;j<3;j++)
      {
      bWriteArray[i][j] = G_bTestPats[n];
      }
    }
  ioGammaLutWriteMD(0,(unsigned char *) bWriteArray,768);

  /****************************************
  * Read back the data
  ****************************************/
  ioGammaLutReadMD(0,(unsigned char *) bReadArray,768);

  /* Is what you read what you wrote? */
  for (i=0;i<256;i++)
    {
    for (j=0;j<3;j++)
      {

      if (bReadArray[i][j] != bWriteArray[i][j])
	{
	printf("GAMMA PALETTE READ ERROR  Location %x, %x Expected %02x Actual %02x\n",
	       i,j,bWriteArray[i][j],bReadArray[i][j]);
	}
      } /* for j */
    } /* for i */
  } /* for n */
ioInitMD(NULL);
}/* End Test2080GammaPalette() */

/**********************************************************
*
*       File Name:  Test2080.c
*
*       Module Abstract: This module tests the Color palette.
*
*       Calling Sequence:
*               Test2080ColorPalette();
*
*       Input Parameters:
*               none
*
*       Output Parameters:
*               none
*
*       Global Variables:
*       G_bTestPats[MAXPATTERNS]
***********************************************************
*       Author: Kyle Pratt
*       Date:   1/28/93
*
*       Revision History:
*       WHO             WHEN            WHAT/WHY/HOW
*
*
*********************************************************/

void Test2080ColorPalette()
{
int i,j,iCount=0,n;
unsigned char bWriteVal,bReadVal,bTemp;
unsigned char bSaveArray[256][3];
unsigned char bWriteArray[256][3];
unsigned char bReadArray[256][3];
/* Get the dac mode and make it 8 bit */
bTemp = ioAnalogSetupReadMD();
ioAnalogSetupWriteMD(bTemp | 0x2);
/*************************************************
* Save off the lut
*************************************************/
ioColorPaletteReadMD(0,(unsigned char *) bSaveArray,768);

/****************************************************
* Test the color palette with address dependent data
*****************************************************/
for (i=0;i<256;i++)
  {
  for (j=0;j<3;j++)
    {
    bWriteArray[i][j] = iCount;
    iCount++;
    }
  }
ioColorPaletteWriteMD(0,(unsigned char *) bWriteArray,768);

/****************************************
* Read back the data
****************************************/
ioColorPaletteReadMD(0,(unsigned char *) bReadArray,768);

/* Is what you read what you wrote? */
for (i=0;i<256;i++)
  {
  for (j=0;j<3;j++)
    {

    if (bReadArray[i][j] != bWriteArray[i][j])
      {
      printf("COLOR PALETTE READ ERROR  Location %x, %x Expected %02x Actual %02x\n",
	     i,j,bWriteArray[i][j],bReadArray[i][j]);
      }
    } /* for j */
  } /* for i */

/****************************************************
* Test the color palette with the test array data
*****************************************************/
for (n=0;n<MAXPATTERNS;n++)
  {
  for (i=0;i<256;i++)
    {
    for (j=0;j<3;j++)
      {
      bWriteArray[i][j] = G_bTestPats[n];
      }
    }
  ioColorPaletteWriteMD(0,(unsigned char *) bWriteArray,768);

  /****************************************
  * Read back the data
  ****************************************/
  ioColorPaletteReadMD(0,(unsigned char *) bReadArray,768);

  /* Is what you read what you wrote? */
  for (i=0;i<256;i++)
    {
    for (j=0;j<3;j++)
      {

      if (bReadArray[i][j] != bWriteArray[i][j])
	{
	printf("COLOR PALETTE READ ERROR  Location %x, %x Expected %02x Actual %02x\n",
	       i,j,bWriteArray[i][j],bReadArray[i][j]);
	}
      } /* for j */
    } /* for i */
  } /* for n */
/* Restore the asc reg */
ioAnalogSetupWriteMD(bTemp);
/* Restore the array */
ioColorPaletteWriteMD(0,(unsigned char *) bSaveArray,768);

}/* End Test2080ColorPalette() */


