#include <stdio.h>
#include <errno.h>

#include "xr.h"
#include "remote.h"
#include "tv_image.h"

#define STARTING_X  346
#define STARTING_Y  240
#define MAX_X       1024
#define MAX_Y       768
#define MIN_X       80
#define MIN_Y       60
#define XS 40
#define YS 40
#define MAX_XSIZE 346L
#define MAX_YSIZE 240L
#define X_RES   640


int	card_present = 0;

FL_FORM     *form;
FL_OBJECT   *obj;
XImage      *ximage;
Display     *disp;
Window      tv_win, win;
Screen      *screen;
GC          gc;
Colormap    cmap;
int         screen_num;
int			depth;
unsigned short  cap_buf[500000];

Window tv_create_win( void )
{
    Window  tv;
	FILE	*input;
	long	i;
	unsigned int	ch, ch2, ch3;

    XGCValues values;

    fl_initial_winsize( STARTING_X, STARTING_Y );
    fl_winminsize( 0, MIN_X, MIN_Y );
    fl_winmaxsize( 0, MAX_X, MAX_Y );
//  fl_winaspect( 0, STARTING_X, STARTING_Y );
    fl_winbackground( 0, 7 );
    tv = fl_winopen( "TV" );
//    fl_set_event_callback( tv_callback, 0 );

    win = tv;

    disp = XOpenDisplay( "localhost:0.0" );
    gc = XCreateGC(disp, win, 0, &values );
    screen = DefaultScreenOfDisplay(disp);
    screen_num = DefaultScreen(disp);
	depth = DefaultDepthOfScreen(screen);
    ximage = XCreateImage(disp, DefaultVisual(disp,screen_num), depth,
        ZPixmap, 0, (char *)cap_buf, 346, 240, depth, 0 );

    cmap = XCreateColormap( disp, win, DefaultVisual( disp, screen_num ),
        AllocNone);
    XSetWindowColormap(disp, win, cmap );

    printf( "Screen depth: %d\n", depth );

	input = fopen( "sample.raw", "r" );

	for ( i = 0; i < 346 * 240 / ( 16 / iImageDepth ); i++ )
	{
		cap_buf[ i ] = 0;

		switch( iImageDepth )
		{
			case  8:	ch = fgetc( input );
						ch2 = fgetc( input );

						cap_buf[ i ] = ch << 8;
						cap_buf[ i ] |= ch2;

						break;

			case 16:	ch = fgetc( input );
						cap_buf[ i ] = ( ch << 8 ) & 0xf800;

						ch = fgetc( input );
						cap_buf[ i ] |= ( ch << 5 ) & 0x07e0;

						ch = fgetc( input );
						cap_buf[ i ] |= ( ch >> 0 ) & 0x001f;

						break;
		}
	}

	fclose( input );

    XPutImage(disp, win, gc, ximage, 0, 0, 0, 0, 346, 240 );
	XFlush(disp);

    return tv;
}

void SetAudioMute(int iMute)
{
	// empty placeholder function.
}

int tnrChangeChannel( float *f1, char c, float *f2 )
{
	// empty placeholder function.
}

int main(int argc,char *argv[])
{
	FL_OBJECT * object;

	fl_initialize(&argc, argv, "X-Remote", 0, 0); 

	/* set this to 0 for testing w/o toughing card */
	card_present = 0;

	remote_setup();

	tv_win = tv_create_win();

	iCurrentVolume = 75;
	set_volume();
	iCurrentChannel = 3;
	set_channel();

	do
	{
		object=fl_do_forms();
	}
	while(object != form0->power);

	return(0);
}
